import javax.swing.*;

public class Country {
    private String name;
    private String region;
    private double lat;
    private double lng;
    private ImageIcon flag;

    public Country(String name, String region, double lat, double lng) {
        setName(name);
        setRegion(region);
        setLat(lat);
        setLng(lng);
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public void setRegion(String region) {
        this.region = region;
    }

    public void setLat(double lat) {
        this.lat = lat;
    }

    public void setLng(double lng) {
        this.lng = lng;
    }

    public int distanceTo(Country country) {
        if ((this.lat == country.lat) && (this.lng == country.lng)) {
            return 0;
        } else {
            double theta = this.lng - country.lng;
            Double dist = Math.sin(Math.toRadians(this.lat)) * Math.sin(Math.toRadians(country.lat)) + Math.cos(Math.toRadians(this.lat)) * Math.cos(Math.toRadians(country.lat)) * Math.cos(Math.toRadians(theta));
            dist = Math.acos(dist);
            dist = Math.toDegrees(dist);
            dist = dist * 60 * 1.1515;
            // Kilometers
            dist = dist * 1.609344;
            return dist.intValue();
        }
    }

    @Override
    public String toString() {
        return "Country{" +
                "name='" + name + '\'' +
                ", region='" + region + '\'' +
                ", lat=" + lat +
                ", lng=" + lng +
                '}';
    }
}
