import javax.swing.*;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

public class WeightView extends JPanel implements ItemListener {
    private Weight weightObj;
    private JLabel label;
    private JComboBox<Integer> comboBox;

    WeightView(Weight weightObj) {
        setWeightObj(weightObj);
        this.label = new JLabel();
        this.label.setText("Weight (kilograms)");
        this.comboBox = new JComboBox<>(this.getWeightObj().getValuesArray());
        if (this.getWeightObj().getWeight() != 0)
            this.comboBox.setSelectedItem(this.getWeightObj().getWeight());
        else
            this.comboBox.setSelectedItem(this.getWeightObj().getDefaultWeight());
        this.comboBox.addItemListener(this);
        add(label);
        add(comboBox);
    }

    public Weight getWeightObj() {
        return weightObj;
    }

    public void setWeightObj(Weight weightObj) {
        this.weightObj = weightObj;
    }

    public JComboBox<Integer> getComboBox() {
        return comboBox;
    }

    @Override
    public void itemStateChanged(ItemEvent event) {
        if (event.getStateChange() == ItemEvent.SELECTED) {
            Object item = event.getItem();
            PersonLeftPanel personLeftPanel = MainWindowsView.getInstance().getCurrentPersonView().getPersonPanel().getLeftPanel();
            personLeftPanel.drawWeight((int) item);
        }
    }
}
